<?php

namespace Intergo\Shortlinks;

use Intergo\Shortlinks\Enums\ShortlinksEnum;
use Illuminate\Support\Collection;
use Illuminate\Support\Facades\DB;

class ShortlinksRepository
{
    private DB $db;
    private string $connection;

    public function __construct(DB $db, $connection)
    {
        $this->db = $db;
        $this->connection = $connection;
    }

    /**
     * @param $authUserId
     * @return Collection
     */
    public function getUserShortlinks($authUserId)
    {
        $shortlinks = ShortlinksEnum::SHORTLINKS_TABLE;
        $users = ShortlinksEnum::USERS_TABLE;
        return $this->db::connection($this->connection)->table($shortlinks)
            ->join($users, "$users.id", '=', "$shortlinks.user_id")
            ->where("$users._id", '=', $authUserId)->get(["$shortlinks.*"]);
    }

    /**
     * @param $shortlinkId
     * @param $attributes
     * @return void
     */
    public function updateShortlink($shortlinkId, $attributes)
    {
        $this->db::connection($this->connection)->table(ShortlinksEnum::SHORTLINKS_TABLE)
            ->where('id', $shortlinkId)
            ->update($attributes);
    }
}
